##Terraform and its management of DNS in route53
#### automatedbytes.com
##Setup the domain in route53
resource "aws_route53_zone" "automatedbytes" {
    name = "automatedbytes.com"
}

#Route53 DNS entry
resource "aws_route53_record" "automatedbytes" {
    zone_id = "${aws_route53_zone.automatedbytes.zone_id}"
    name = "automatedbytes.com"
    type = "A"
    ttl = "5"
    records = ["${var.vultr_ip}"]
}

resource "aws_route53_record" "www_automatedbytes" {
    zone_id = "${aws_route53_zone.automatedbytes.zone_id}"
    name = "www.automatedbytes.com"
    type = "CNAME"
    ttl = "5"
    records = ["${aws_route53_record.automatedbytes.name}"]
}

resource "aws_route53_record" "wildcard_automatedbytes" {
    zone_id = "${aws_route53_zone.automatedbytes.zone_id}"
    name = "*.automatedbytes.com"
    type = "CNAME"
    ttl = "5"
    records = ["${aws_route53_record.automatedbytes.name}"]
}

resource "aws_route53_record" "support_automatedbytes" {
    zone_id = "${aws_route53_zone.automatedbytes.zone_id}"
    name = "support.automatedbytes.com"
    type = "A"
    ttl = "5"
    records = ["${var.home_ip}"]
}

resource "aws_route53_record" "kfa_support_automatedbytes" {
    zone_id = "${aws_route53_zone.automatedbytes.zone_id}"
    name = "kfa.support.automatedbytes.com"
    type = "CNAME"
    ttl = "5"
    records = ["support.automatedbytes.com"]
}

## Email MX records
resource "aws_route53_record" "mx_automatedbytes" {
    zone_id = "${aws_route53_zone.automatedbytes.zone_id}"
    name = "${aws_route53_zone.automatedbytes.name}"
    type = "MX"
    ttl = "60"
    records = ["1 ASPMX.L.GOOGLE.COM",
           "5 ALT1.ASPMX.L.GOOGLE.COM",
           "5 ALT2.ASPMX.L.GOOGLE.COM",
           "10 ALT3.ASPMX.L.GOOGLE.COM",
           "10 ALT4.ASPMX.L.GOOGLE.COM"]
}

### automatedbytes.ca
#Setup the domain in route53
#resource "aws_route53_zone" "automatedbytes_ca" {
#    name = "automatedbytes.ca"
#}
#
#resource "aws_route53_record" "automatedbytes_ca" {
#    zone_id = "${aws_route53_zone.automatedbytes_ca.zone_id}"
#    name = "automatedbytes.ca"
#    type = "A"
#    ttl = "5"
#    records = ["${var.home_ip}"]    
#}
#
#resource "aws_route53_record" "www_automatedbytes_ca" {
#    zone_id = "${aws_route53_zone.automatedbytes_ca.zone_id}"
#    name = "www.automatedbytes.ca"
#    type = "CNAME"
#    ttl = "5"
#    records = ["${aws_route53_record.automatedbytes_ca.name}"]
#}
#
#resource "aws_route53_record" "wildcard_automatedbytes_ca" {
#    zone_id = "${aws_route53_zone.automatedbytes_ca.zone_id}"
#    name = "*.automatedbytes.ca"
#    type = "CNAME"
#    ttl = "5"
#    records = ["${aws_route53_record.automatedbytes_ca.name}"]
#}
